diff --git a/hw/pci-host/piix.c b/hw/pci-host/piix.c
index e0e0946..a9a5570 100644
--- a/hw/pci-host/piix.c
+++ b/hw/pci-host/piix.c
@@ -305,25 +305,14 @@ static int i440fx_initfn(PCIDevice *dev)
     return 0;
 }
 
-PCIBus *i440fx_init(PCII440FXState **pi440fx_state,
-                    int *piix3_devfn,
-                    ISABus **isa_bus, qemu_irq *pic,
-                    MemoryRegion *address_space_mem,
-                    MemoryRegion *address_space_io,
-                    ram_addr_t ram_size,
-                    ram_addr_t below_4g_mem_size,
-                    ram_addr_t above_4g_mem_size,
-                    MemoryRegion *pci_address_space,
-                    MemoryRegion *ram_memory)
+static void i440fx_pci_host_create(DeviceState **dev_bridge,
+                                   PCIBus **bus_bridge,
+                                   MemoryRegion *address_space_io,
+                                   MemoryRegion *pci_address_space)
 {
     DeviceState *dev;
     PCIBus *b;
-    PCIDevice *d;
     PCIHostState *s;
-    PIIX3State *piix3;
-    PCII440FXState *f;
-    unsigned i;
-    I440FXState *i440fx;
 
     dev = qdev_create(NULL, TYPE_I440FX_PCI_HOST_BRIDGE);
     s = PCI_HOST_BRIDGE(dev);
@@ -333,8 +322,48 @@ PCIBus *i440fx_init(PCII440FXState **pi440fx_state,
     object_property_add_child(qdev_get_machine(), "i440fx", OBJECT(dev), NULL);
     qdev_init_nofail(dev);
 
-    d = pci_create_simple(b, 0, TYPE_I440FX_PCI_DEVICE);
+    *bus_bridge = b;
+    *dev_bridge = dev;
+}
+
+static PCIDevice *i440fx_pci0_create(PCIBus **bus_bridge,
+                                     const char *type,
+                                     PCII440FXState **pi440fx_state)
+{
+    PCIBus *b;
+    PCIDevice *d;
+
+    b = *bus_bridge;
+
+    d = pci_create_simple(b, 0, type);
     *pi440fx_state = I440FX_PCI_DEVICE(d);
+    return d;
+}
+
+static PCIBus *i440fx_pci_setup(DeviceState **dev_bridge,
+                                PCIBus **bus_bridge,
+                                PCIDevice *d,
+                                PCII440FXState **pi440fx_state,
+                                int *piix3_devfn,
+                                ISABus **isa_bus, qemu_irq *pic,
+                                MemoryRegion *address_space_mem,
+                                MemoryRegion *address_space_io,
+                                ram_addr_t ram_size,
+                                ram_addr_t below_4g_mem_size,
+                                ram_addr_t above_4g_mem_size,
+                                MemoryRegion *pci_address_space,
+                                MemoryRegion *ram_memory)
+{
+    DeviceState *dev;
+    PCIBus *b;
+    PCII440FXState *f;
+    I440FXState *i440fx;
+    unsigned i;
+    PIIX3State *piix3;
+
+    b = *bus_bridge;
+    dev = *dev_bridge;
+
     f = *pi440fx_state;
     f->system_memory = address_space_mem;
     f->pci_address_space = pci_address_space;
@@ -392,6 +421,36 @@ PCIBus *i440fx_init(PCII440FXState **pi440fx_state,
     return b;
 }
 
+PCIBus *i440fx_init(PCII440FXState **pi440fx_state,
+                    int *piix3_devfn,
+                    ISABus **isa_bus,
+                    qemu_irq *pic,
+                    MemoryRegion *address_space_mem,
+                    MemoryRegion *address_space_io,
+                    ram_addr_t ram_size,
+                    ram_addr_t below_4g_mem_size,
+                    ram_addr_t above_4g_mem_size,
+                    MemoryRegion *pci_address_space,
+                    MemoryRegion *ram_memory)
+{
+    PCIDevice *d;
+    DeviceState *dev_bridge;
+    PCIBus *bus_bridge;
+
+    i440fx_pci_host_create(&dev_bridge, &bus_bridge, address_space_io,
+                           pci_address_space);
+
+    d = i440fx_pci0_create(&bus_bridge, TYPE_I440FX_PCI_DEVICE, pi440fx_state);
+
+    bus_bridge = i440fx_pci_setup(&dev_bridge, &bus_bridge, d, pi440fx_state,
+                                  piix3_devfn, isa_bus, pic, address_space_mem,
+                                  address_space_io, ram_size, below_4g_mem_size,
+                                  above_4g_mem_size, pci_address_space,
+                                  ram_memory);
+
+    return bus_bridge;
+}
+
 PCIBus *find_i440fx(void)
 {
     PCIHostState *s = OBJECT_CHECK(PCIHostState,